/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 *                                                                         *
 *  Copyright (C) 2021-2022 mirk0dex                                       *
 *  <mirkodi.tech>                                                         *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>. *
 *                                                                         *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                                                         *
 * LibreMiser: a free loudness maximiser LV2 plugin.                       *
 *                                                                         *
 * Deps:                                                                   *
 * LV2                                                                     *
 *                                                                         *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <lv2/core/lv2.h>
#include <math.h>
#include <stdint.h>
#include <stdlib.h>

#define MISER_URI "https://git.mirkodi.tech/mirk0dex/LibreMiser"

typedef enum {
  THRESHOLD = 0,
  LIMIT     = 1,
  INPUT     = 2,
  OUTPUT    = 3
}
  PortIndex;

typedef struct {
  // Port buffers
  const float* threshold;
  const float* limit;
  const float* input;
  float*       output;
}
  Miser;

static LV2_Handle instantiate (const LV2_Descriptor*     descriptor,
                               double                    rate,
                               const char*               bundle_path,
                               const LV2_Feature* const* features) {
  Miser* miser = (Miser*)calloc(1, sizeof(Miser));

  return (LV2_Handle)miser;
}

static void connect_port(LV2_Handle instance, uint32_t port, void* data) {
  Miser* miser = (Miser*)instance;

  switch ((PortIndex)port) {
  case THRESHOLD:
    miser -> threshold = (const float*)data;
    break;
  case LIMIT:
    miser -> limit     = (const float*)data;
    break;
  case INPUT:
    miser -> input     = (const float*)data;
    break;
  case OUTPUT:
    miser -> output    = (float*)data;
    break;
  }
}

static void activate(LV2_Handle instance) {}

#define

int main() {return 0;}
